<?php

/*
+==========================================================================+
| Admin Secure Support Functions                                           |
| Version 1.2                                                              |
| Copyright (c) 2003-2004 Madman                                           |
| http://gp4tweaker.vadertrophy.com                                        |
+--------------------------------------------------------------------------+
| Disclaimer: You run this package at your sole risk. Author cannot be     |
| held liable if anything goes wrong. You are advised to test this package |
| on a development system. Backup everything before implementing in a      |
| production environment. If something goes wrong, you can always backout  |
| and restore your backups.                                                |
|                                                                          |
| Terms and Conditions: Installing and running this also means you agree   |
| to the terms of usages and conditions to this package. As always, make   |
| a backup before messing with anything. All code release by me is         |
| considered sample code only. It may be fully functual, but you use it    |
| at your own risk, if you break it, you get to fix it too. No waranty is  |
| given or implied. All original header code and copyright messages        |
| will be maintained to give credit where credit is due. If you modify     |
| this, the only requirement is that you also maintain all original        |
| copyright messages. Released under GNU/General Public License.           |
|                                                                          |
| This program is free software; you can redistribute it and/or modify     |
| it under the terms of the GNU General Public License as published by     |
| the Free Software Foundation; either version 2 of the License, or        |
| (at your option) any later version.                                      |
+==========================================================================+
*/

if (eregi("asfunc.php", $_SERVER[PHP_SELF])) { die(); }

/*
+--------------------------------------------------------------------------+
|                      DO NOT EDIT BELOW THIS LINE                         |
+--------------------------------------------------------------------------+
*/

function asec_getConfigPath() {
	global $forum_admin, $inside_mod;
	$ret = "includes/";
	if (!isset($forum_admin) && !isset($inside_mod)) { return $ret; }
	if ($forum_admin == 1) $ret = "../../../includes/";
	elseif ($inside_mod == 1) $ret = "../../includes/";
	return $ret;
}

function asec_fetchAdminCookie($admin) {
	global $prefix, $db;
	$ret['aid']  = "";
	$ret['name'] = "";
	$ret['pwd']  = "";
	$ret['sup']  = "";
	$ret['lang'] = "";
	if (!isset($admin)) { return $ret; }
	if(!is_array($admin)) {
		$array_admin = explode(":", base64_decode($admin));
		$aid = "$array_admin[0]";
		$pwd = "$array_admin[1]";
		$lng = "$array_admin[2]";
	} else {
		$aid = "$admin[0]";
		$pwd = "$admin[1]";
		$lng = "$admin[2]";
	}
	if (($aid == "") || ($pwd == "")) { return $ret; }

	$aid = substr($aid, 0, 25);
	if (eregi("([\\\"\',=#]+)", $aid)) { return $ret; }

	$sql = "SELECT name, pwd, radminsuper FROM ".$prefix."_authors WHERE aid='$aid'";
	$result = $db->sql_query($sql);
	if (!$result) { return $ret; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return $ret; }
	$name = $row['name'];
	$sup  = $row['radminsuper'];
	$pass = $row['pwd'];
	if(($pass != $pwd) || ($pass == "")) { return $ret; }
	$ret['aid']  = $aid;
	$ret['name'] = $name;
	$ret['pwd']  = $pwd;
	$ret['sup']  = $sup;
	$ret['lang'] = $lng;
	return $ret;
}

function asec_isLocalIP($uip) {
	$ret = 0;
	$sip = split("\.", "$uip");
	$ipn = ($sip[3] + $sip[2] * 256 + $sip[1] * 65536 + $sip[0] * 16777216);
	if ($ipn == 0) $ret = 1;
	else if ($ipn == 2130706433) $ret = 1;
	else if ($ipn == 4294967295) $ret = 1;
	else if (($ipn >= 3232235520) && ($ipn <= 3232235775)) $ret = 1;
	return $ret;
}

function asec_getRealIP() {
	if (isset($_SERVER['HTTP_CLIENT_IP'])) $ip_client = $_SERVER['HTTP_CLIENT_IP'];
	if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $ip_forward = $_SERVER['HTTP_X_FORWARDED_FOR'];
	if (isset($_SERVER['REMOTE_ADDR'])) $ip_remote = $_SERVER['REMOTE_ADDR'];
	if (isset($ip_forward) && !isset($ip_client)) {
		$ip_forward = str_replace("\"", "", $ip_forward);
		$ip_collect = explode(",", $ip_forward);
		for ($i=0;$i<count($ip_collect);$i++) {
			$ip_test = trim($ip_collect[$i]);
			if (!strcasecmp($ip_test, "unknown")) unset($ip_collect[$i]);
			else if (asec_isLocalIP($ip_test)) unset($ip_collect[$i]);
		}
		$ip_collect = array_values($ip_collect);
		unset($ip_forward);
		if (count($ip_collect) > 0) $ip_forward = end($ip_collect);
	}
	if (isset($ip_client)) $aip = $ip_client;
	else if (isset($ip_forward)) $aip = $ip_forward;
	else if (isset($ip_remote)) $aip = $ip_remote;
	else $aip = "unknown";
	return $aip;
}

function asec_createDB() {
	global $db;
	include(asec_getConfigPath()."asconfig.php");

	$db->sql_query("DROP TABLE IF EXISTS ".$asec_dbtable);
	$sql = "CREATE TABLE ".$asec_dbtable." ("
		."aid varchar(25) NOT NULL default '', "
		."name varchar(50) NOT NULL default '', "
		."pwd varchar(40) NOT NULL default '', "
		."radminsuper int(1) NOT NULL default '0', "
		."lastupdate int(11) unsigned NOT NULL default '0', "
		."PRIMARY KEY (aid), "
		."KEY aid (aid), "
		."KEY name (name) "
		.") TYPE=MyISAM";
	if (!$db->sql_query($sql)) { return 0; }

	$db->sql_query("DROP TABLE IF EXISTS ".$asec_dbconfig);
	$sql = "CREATE TABLE ".$asec_dbconfig." ("
		."asc_name varchar(255) NOT NULL default '', "
		."asc_value varchar(255) NOT NULL default '', "
		."PRIMARY KEY (asc_name) "
		.") TYPE=MyISAM";
	if (!$db->sql_query($sql)) { return 0; }

	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('check_time', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('check_days', '1')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('last_check', '".sprintf("%u", time())."')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('admin_mail_address', 'yourname@yoursite.com')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('send_notify_mail_to', 'yourname@yoursite.com')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('auto_sync', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_dbquery_vars', '1')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_admin_var', '1')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_extern_file', '1')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('filter_script_vars', '1')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_check', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_account_change', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_dbquery_vars', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_admin_var', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_extern_file', '0')");
	$db->sql_query("INSERT INTO ".$asec_dbconfig." VALUES ('mail_notify_script_vars', '0')");

	return 1;
}

function asec_getConfig() {
	global $db;
	include(asec_getConfigPath()."asconfig.php");

	$ret = array();
	$result = $db->sql_query("SELECT * FROM ".$asec_dbconfig);
	if (!$result) { return $ret; }
	while ($row = $db->sql_fetchrow($result)) {
		$name  = $row['asc_name'];
		$value = $row['asc_value'];
		$ret[$name] = $value;
	}
	return $ret;
}

function asec_mailNotify($type = 0, $more_info = "") {
	$config = asec_getConfig();

	$mail_send = 0;
	$mail_admin = strval($config['admin_mail_address']);
	$mail_from = "Admin Secure <$mail_admin>";
	$mail_to   = strval($config['send_notify_mail_to']);
	$mail_date = date("j F Y, H:i", time());
	$mail_pri  = "Normal";

	$checkip   = asec_getRealIP();
	$userip    = ($checkip != "unknown") ? $checkip : "";
	$checkhost = ($checkip != "unknown") ? @gethostbyaddr($checkip) : "";
	$userhost  = ($checkip != $checkhost) ? $checkhost : "";
	$useragent = $_SERVER['HTTP_USER_AGENT'];
	$referer   = $_SERVER['HTTP_REFERER'];

	$type = intval($type);
	switch ($type) {

		case 0:
			if (intval($config['mail_notify_check']) != 0) {
				$checkdays    = intval($config['check_days']);
				$perdays      = ($checkdays > 1) ? "$checkdays days" : "day";

				$mail_subject = "Regular Report";
				$mail_body    = "This e-mail sent to you periodically once per ".$perdays." for automatic checkings performed by Admin Secure.\n";

				if ($more_info != "") { $mail_body .= $more_info; }

				$mail_send    = 1;
			}
			break;

		case 1:
			if (intval($config['mail_notify_account_change']) != 0) {
				$mail_subject = "Account Changed";
				$mail_body    = "Admnin Secure detecting one or more admin accounts has been changed. ";
				$mail_body   .= "These accounts need an approval before they grant admin access rights.\n";

				if ($more_info != "") { $mail_body .= "Admin accounts that need an approval:\n\n".$more_info; }

				$mail_pri     = "High";
				$mail_send    = 1;
			}
			break;

		case 2:
			if (intval($config['mail_notify_dbquery_vars']) != 0) {
				$mail_subject = "Database Query Breach!";
				$mail_body    = "Admnin Secure detecting database query from input variable. ";
				$mail_body   .= "This is possibly a suspicious SQL Injection hacking activity on your website. ";
				$mail_body   .= "Admin Secure has been collecting these following information:\n\n";
				$mail_body   .= "- Date: $mail_date\n";

				if ($userip != "")     { $mail_body .= "- IP Address: $userip\n"; }
				if ($userhost != "")   { $mail_body .= "- Host: $userhost\n"; }
				if ($useragent != "")  { $mail_body .= "- User-agent: $useragent\n"; }
				if ($referer != "")    { $mail_body .= "- Referer: $referer\n"; }
				if ($more_info != "")  { $mail_body .= $more_info; }

				$mail_pri     = "High";
				$mail_send    = 1;
			}
			break;

		case 3:
			if (intval($config['mail_notify_admin_var']) != 0) {
				$mail_subject = "Admin Info Breach!";
				$mail_body    = "Admnin Secure detecting admin account passed from input variable. ";
				$mail_body   .= "This is possibly a suspicious admin account hacking activity on your website. ";
				$mail_body   .= "Admin Secure has been collecting these following information:\n\n";
				$mail_body   .= "- Date: $mail_date\n";

				if ($userip != "")     { $mail_body .= "- IP Address: $userip\n"; }
				if ($userhost != "")   { $mail_body .= "- Host: $userhost\n"; }
				if ($useragent != "")  { $mail_body .= "- User-agent: $useragent\n"; }
				if ($referer != "")    { $mail_body .= "- Referer: $referer\n"; }
				if ($more_info != "")  { $mail_body .= $more_info; }

				$mail_pri     = "High";
				$mail_send    = 1;
			}
			break;

		case 4:
			if (intval($config['mail_notify_extern_file']) != 0) {
				$mail_subject = "External File Linking!";
				$mail_body    = "Admnin Secure detecting external file linking through module inclusion. ";
				$mail_body   .= "This is possibly a suspicious hacking attempt activity on your website. ";
				$mail_body   .= "Admin Secure has been collecting these following information:\n\n";
				$mail_body   .= "- Date: $mail_date\n";

				if ($userip != "")     { $mail_body .= "- IP Address: $userip\n"; }
				if ($userhost != "")   { $mail_body .= "- Host: $userhost\n"; }
				if ($useragent != "")  { $mail_body .= "- User-agent: $useragent\n"; }
				if ($referer != "")    { $mail_body .= "- Referer: $referer\n"; }
				if ($more_info != "")  { $mail_body .= $more_info; }

				$mail_pri     = "High";
				$mail_send    = 1;
			}
			break;

		case 5:
			if (intval($config['mail_notify_script_vars']) != 0) {
				$mail_subject = "Illegal Scripting Code!";
				$mail_body    = "Admnin Secure detecting illegal scripting code from user input. ";
				$mail_body   .= "This is possibly a suspicious hacking attempt activity on your website. ";
				$mail_body   .= "Admin Secure has been collecting these following information:\n\n";
				$mail_body   .= "- Date: $mail_date\n";

				if ($userip != "")     { $mail_body .= "- IP Address: $userip\n"; }
				if ($userhost != "")   { $mail_body .= "- Host: $userhost\n"; }
				if ($useragent != "")  { $mail_body .= "- User-agent: $useragent\n"; }
				if ($referer != "")    { $mail_body .= "- Referer: $referer\n"; }
				if ($more_info != "")  { $mail_body .= $more_info; }

				$mail_pri     = "High";
				$mail_send    = 1;
			}
			break;

	}
	if ($mail_send) {
		$mail_body   .= "\nNote:\nYou can turn-off mail notification from Admin Secure configuration setting.\n\n";
		$mail_body   .= "---\nAdmin Secure Messaging System.\n";
		@mail($mail_to, $mail_subject, $mail_body, "From: $mail_from\nPriority: $mail_pri\nX-Mailer: PHP/".phpversion());
	}
}

function asec_isCheckTime() {
	global $db;
	include(asec_getConfigPath()."asconfig.php");

	$config = asec_getConfig();
	$checktime = intval($config['check_time']);
	$checkdays = intval($config['check_days']);
	$lastcheck = intval($config['last_check']);

	if ($lastcheck != 0) {
		$datecheck = getdate($lastcheck);
		$daycheck  = mktime(0, 0, 0, $datecheck['mon'], $datecheck['mday'], $datecheck['year']);
	} else {
		$daycheck  = 0;
	}

	$thistime  = floatval(time());
	$nexttime  = floatval($checkdays * 86400 + $daycheck + $checktime);

	if ($thistime >= $nexttime) {
		$db->sql_query("UPDATE FROM ".$asec_dbconfig." SET asc_value='$thistime' WHERE asc_name='last_check'");
		return 1;
	}
	return 0;
}

function asec_checkSyncDB() {
	global $prefix, $db;
	include(asec_getConfigPath()."asconfig.php");

	$num1 = $db->sql_numrows($db->sql_query("SELECT aid FROM ".$prefix."_authors"));
	$num2 = $db->sql_numrows($db->sql_query("SELECT aid FROM ".$asec_dbtable));
	if ($num1 != $num2) { return 0; }
	$result = $db->sql_query("SELECT name, aid, pwd, radminsuper FROM ".$prefix."_authors");
	if (!$result) { return 0; }
	while ($row = $db->sql_fetchrow($result)) {
		$name = $row['name'];
		$aid  = $row['aid'];
		$pwd  = $row['pwd'];
		$sup  = $row['radminsuper'];
		$result2 = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$asec_dbtable." WHERE aid='$aid'");
		if (!$result2) { return 0; }
		list($name2, $pwd2, $sup2) = $db->sql_fetchrow($result2);
		if (($name != $name2) || ($pwd != $pwd2) || ($sup != $sup2)) { return 0; }
	}
	return 1;
}

function asec_syncDB() {
	global $prefix, $db;
	include(asec_getConfigPath()."asconfig.php");

	$lud = sprintf("%u", time());
	$result = $db->sql_query("SELECT name, aid, pwd, radminsuper FROM ".$prefix."_authors");
	if (!$result) { return 0; }
	while ($row = $db->sql_fetchrow($result)) {
		$name = $row['name'];
		$aid  = $row['aid'];
		$pwd  = $row['pwd'];
		$sup  = $row['radminsuper'];
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$aid'"));
		if ($num == 0) {
			$sql = "INSERT INTO ".$asec_dbtable." (name, aid, pwd, radminsuper, lastupdate) VALUES ('$name', '$aid', '$pwd', '$sup', '$lud')";
		} else {
			$sql = "UPDATE ".$asec_dbtable." SET pwd='$pwd', radminsuper='$sup', lastupdate='$lud' WHERE aid='$aid'";
		}
		$result2 = $db->sql_query($sql);
		if (!$result2) { return 0; }
	}
	$db->sql_query("DELETE FROM ".$asec_dbtable." WHERE lastupdate < $lud");
	return 1;
}

function asec_syncAdmin($aid) {
	global $prefix, $db;
	include(asec_getConfigPath()."asconfig.php");

	$aid = substr($aid, 0, 25);
	if (eregi("([\\\"\',=#]+)", $aid)) { return 1; }

	$lud = sprintf("%u", time());
	$result = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$prefix."_authors WHERE aid='$aid'");
	if (!$result) { return 0; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return 0; }
	$name = $row['name'];
	$pwd  = $row['pwd'];
	$sup  = $row['radminsuper'];
	$num  = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$aid'"));
	if ($num == 0) {
		$sql = "INSERT INTO ".$asec_dbtable." (name, aid, pwd, radminsuper, lastupdate) VALUES ('$name', '$aid', '$pwd', '$sup', '$lud')";
	} else {
		$sql = "UPDATE ".$asec_dbtable." SET pwd='$pwd', radminsuper='$sup', lastupdate='$lud' WHERE aid='$aid'";
	}
	$result = $db->sql_query($sql);
	if (!$result) { return 0; }
	return 1;
}

function asec_unsyncAdmin($aid) {
	global $db;
	include(asec_getConfigPath()."asconfig.php");

	$aid = substr($aid, 0, 25);
	if (eregi("([\\\"\',=#]+)", $aid)) { return 1; }

	$result = $db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$aid'");
	if (!$result) { return 0; }
	if ($row = $db->sql_fetchrow($result)) {
		if ($row['name'] != "God") {
			$sql = "DELETE FROM ".$asec_dbtable." WHERE aid='$aid'";
			$result = $db->sql_query($sql);
			if (!$result) { return 0; }
		}
	}
	return 1;
}

function asec_isAccountMatch($aid) {
	global $prefix, $db;
	include(asec_getConfigPath()."asconfig.php");

	$aid = substr($aid, 0, 25);
	if (eregi("([\\\"\',=#]+)", $aid)) { return 0; }

	$result1 = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$prefix."_authors WHERE aid='$aid'");
	if (!$result1) { return 0; }
	$r1 = $db->sql_fetchrow($result1);
	if (empty($r1)) { return 0; }
	$result2 = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$asec_dbtable." WHERE aid='$aid'");
	if (!$result2) { return 0; }
	$r2 = $db->sql_fetchrow($result2);
	if (empty($r2)) { return 0; }
	if (($r1['name'] != $r2['name']) || ($r1['pwd'] != $r2['pwd']) || ($r1['radminsuper'] != $r2['radminsuper'])) { return 0; }
	return 1;
}

function asec_isAdminAccountMatch($admin) {
	global $db;
	include(asec_getConfigPath()."asconfig.php");

	$adm = asec_fetchAdminCookie($admin);
	if (($adm['aid'] == "") || ($adm['name'] == "") || ($adm['pwd'] == "")) { return 0; }
	$result = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$asec_dbtable." WHERE aid='$adm[aid]'");
	if (!$result) { return 0; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return 0; }
	if (($adm['name'] != $row['name']) || ($adm['pwd'] != $row['pwd']) || ($adm['sup'] != $row['radminsuper'])) { return 0; }
	return 1;
}

function asec_isAdmin($admin) {
	global $db;
	include(asec_getConfigPath()."asconfig.php");

	$adm = asec_fetchAdminCookie($admin);
	if (($adm['aid'] == "") || ($adm['name'] == "") || ($adm['pwd'] == "")) { return 0; }
	$sql = "SELECT name, pwd FROM ".$asec_dbtable." WHERE aid='$adm[aid]'";
	$result = $db->sql_query($sql);
	if (!$result) { return 0; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return 0; }
	if (($adm['name'] != $row['name']) || ($adm['pwd'] != $row['pwd'])) { return 0; }
	return 1;
}

function asec_isGodAdmin($admin) {
	$adm = asec_fetchAdminCookie($admin);
	if (($adm['aid'] == "") || ($adm['name'] == "") || ($adm['pwd'] == "")) { return 0; }
	$admin_name  = trim($adm['name']);
	if ($admin_name != "God") { return 0; }
	return 1;
}

function asec_base64Encode($string) {
	$btbl = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/=";
	$brep = "87MZH54FutsEBaAzyKxwvUTS321rON9qG6poDCn0mXWVlkjihgfRQPedcYJIb*-;L";
	$base = base64_encode($string);
	$bres = "";
	for ($i=0;$i<strlen($base);$i++) {
		$bpos  = strpos($btbl, substr($base,$i,1));
		$bres .= substr($brep,$bpos,1);
	}
	return $bres;
}

function asec_base64Decode($string) {
	$btbl = "87MZH54FutsEBaAzyKxwvUTS321rON9qG6poDCn0mXWVlkjihgfRQPedcYJIb*-;L";
	$brep = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/=";
	$base = trim($string);
	$bres = "";
	for ($i=0;$i<strlen($base);$i++) {
		$bpos  = strpos($btbl, substr($base,$i,1));
		$bres .= substr($brep,$bpos,1);
	}
	return base64_decode($bres);
}

function asec_getMagicValue() {
	include(asec_getConfigPath()."asconfig.php");

	$kmd5 = md5("$asec_rand1"."$asec_rand2");
	$key1 = hexdec(substr($kmd5, 2,8));
	$key2 = hexdec(substr($kmd5,12,8));
	$keys = floatval($key1 + $key2);
	$ktbl = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	$klen = strlen($ktbl);
	$kret = "";
	for ($i = 0; $i < 16; $i++) {
		$mods = intval($keys % $klen);
		$keys = floatval($keys / 5.0);
		$kret.= substr($ktbl,$mods,1);
	}
	return $kret;
}

function asec_createRecallCode($admin) {
	include(asec_getConfigPath()."asconfig.php");

	$adm = asec_fetchAdminCookie($admin);
	$rc1 = "$adm[name]"."$asec_rand1"."$adm[aid]"."$asec_rand2"."$adm[pwd]"."$asec_dbtable";
	$rc2 = "$adm[name]:$adm[aid]:$adm[pwd]";
	$mag = asec_getMagicValue();
	$mc1 = substr($mag,0,8);
	$mc2 = substr($mag,8,8);
	$cod = asec_base64Encode($rc2);
	$csz = intval(strlen($cod)/3);
	$co1 = substr($cod,0,$csz);
	$co2 = substr($cod,$csz,$csz);
	$co3 = substr($cod,$csz*2,$csz+2);
	$ret['auth'] = strtoupper(md5($rc1));
	$ret['code'] = $co1.$mc1.$co2.$mc2.$co3;
	return $ret;
}

function asec_checkRecallCode($auth, $code) {
	include(asec_getConfigPath()."asconfig.php");

	$auth = strtoupper(trim($auth));
	$code = trim($code);
	if (($auth == "") || ($code == "")) { return 0; }
	$clen = intval((strlen($code)-16)/3);
	$base = substr($code,0,$clen).substr($code,$clen+8,$clen).substr($code,$clen*2+16,$clen+2);
	$mag1 = substr($code,$clen,8).substr($code,$clen*2+8,8);
	$mag2 = asec_getMagicValue();
	if ($mag1 != $mag2) { return 0; }
	list($name, $aid, $pwd) = explode(":", asec_base64Decode($base));
	$rc1 = "$name"."$asec_rand1"."$aid"."$asec_rand2"."$pwd"."$asec_dbtable";
	$rc2 = strtoupper(md5($rc1));
	return ($rc2 == $auth) ? 1 : 0;
}

function asec_getApplied() {
	global $prefix, $db;
	include(asec_getConfigPath()."asconfig.php");

	$ret['aid']  = array();
	$ret['name'] = array();
	$result = $db->sql_query("SELECT aid, name FROM ".$prefix."_authors");
	if (!result) { return $ret; }
	while ($row = $db->sql_fetchrow($result)) {
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$row[aid]'"));
		if ($num == 1) {
			if (asec_isAccountMatch($row['aid'])) {
				$ret['aid'][]  = "$row[aid]";
				$ret['name'][] = "$row[name]";
			}
		}
	}
	return $ret;
}

function asec_getNotApplied() {
	global $prefix, $db;
	include(asec_getConfigPath()."asconfig.php");

	$ret['aid']  = array();
	$ret['name'] = array();
	$result = $db->sql_query("SELECT aid, name FROM ".$prefix."_authors");
	if (!result) { return $ret; }
	while ($row = $db->sql_fetchrow($result)) {
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$row[aid]'"));
		if ($num == 0) {
			$ret['aid'][]  = "$row[aid]";
			$ret['name'][] = "$row[name]";
		} else {
			if (!asec_isAccountMatch($row['aid'])) {
				$ret['aid'][]  = "$row[aid]";
				$ret['name'][] = "$row[name]";
			}
            }
	}
	return $ret;
}

function asec_blockRedirect($type) {
	if (file_exists("includes/asredir.php")) {
		$checkip   = asec_getRealIP();
		$userip    = ($checkip != "unknown") ? $checkip : "";
		$checkhost = ($checkip != "unknown") ? @gethostbyaddr($checkip) : "";
		$userhost  = ($checkip != $checkhost) ? $checkhost : "";

		include("includes/asredir.php");
		asec_redirMain($type, $userip, $userhost);
	} else {
		header("Location: index.php");
	}
	die();
}

function asec_check_dbquery_vars($key, $value) {
	if (eregi("([a-z0-9 \._-]*)([\"\' ]*)union([\ ]+)(select|insert|update|delete|create|drop|alter)([a-zA-Z0-9 \"\'\.*,_-]+)(database|table|from|into|set|values)", $value)) {
		$more_info = "- URI: ".$_SERVER['REQUEST_URI']."\n- VAR: \$".$key." = ".$value."\n";
		asec_mailNotify(2, $more_info);
		asec_blockRedirect(2);
	}
}

function asec_check_admin_var() {
	$check  = 0;
	$eheck += (isset($_GET['admin'])) ? 1 : 0;
	$check += (isset($_POST['admin'])) ? 1 : 0;

	if ($check) {
		asec_mailNotify(3);
		asec_blockRedirect(3);
	}
}

function asec_check_extern_file($key, $value) {
	$key_extern_file = array('name', 'file', 'mop');
	if ( ($value != "") && in_array(strtolower($key), $key_extern_file) && eregi("([^a-zA-Z0-9_-]+)", $value) ) {
		$more_info = "- URI: ".$_SERVER['REQUEST_URI']."\n- VAR: \$".$key." = ".$value."\n";
		asec_mailNotify(4, $more_info);
		asec_blockRedirect(4);
	}
}

function asec_check_script_vars($key, $value) {
	if ( eregi("(<[^>]*)script*([^>]*>)", $value) || eregi("^javascript:", $value) ) {
		$more_info = "- URI: ".$_SERVER['REQUEST_URI']."\n- VAR: \$".$key." = ".htmlspecialchars($value, ENT_QUOTES)."\n";
		asec_mailNotify(5, $more_info);
		asec_blockRedirect(5);
	}
}

function asec_performFilterNotify() {
	$config = asec_getConfig();

	reset($_GET);
	foreach ($_GET as $key => $value) {
		if (intval($config['filter_dbquery_vars']) != 0) { asec_check_dbquery_vars($key, $value); }
		if (intval($config['filter_extern_file']) != 0)  { asec_check_extern_file($key, $value); }
		if (intval($config['filter_script_vars']) != 0)  { asec_check_script_vars($key, $value); }
	}
	reset($_GET);

	reset($_POST);
	foreach ($_POST as $key => $value) {
		if (intval($config['filter_dbquery_vars']) != 0) { asec_check_dbquery_vars($key, $value); }
		if (intval($config['filter_extern_file']) != 0)  { asec_check_extern_file($key, $value); }
		if (intval($config['filter_script_vars']) != 0)  { asec_check_script_vars($key, $value); }
	}
	reset($_POST);

	if (isset($_COOKIE['p_msg'])) {
		$value = base64_decode($_COOKIE['p_msg']);
		if (intval($config['filter_dbquery_vars']) != 0) { asec_check_dbquery_vars('p_msg', $value); }
		if (intval($config['filter_script_vars']) != 0) { asec_check_script_vars('p_msg', $value); }
	}

	if (intval($config['filter_admin_var']) != 0) { asec_check_admin_var(); }
}

function asec_performRealTimeNotify() {
	$config = asec_getConfig();

	if (intval($config['mail_notify_account_change']) != 0) {
		$listchanges = asec_getNotApplied();
		$listcount   = count($listchanges['aid']);
		if ($listcount > 0) {
			$moreinfo = "";
			for ($i=0; $i < $listcount; $i++) {
				$moreinfo .= "- ".$listchanges['aid']." (".$listchanges['name'].")\n";
			}
			asec_mailNotify(1, $moreinfo);
		}
	}
}

function asec_performAutoCheckNotify() {
	if (asec_isCheckTime()) {
		$config = asec_getConfig();

		if (intval($config['auto_sync']) != 0) {
			if (!asec_checkSyncDB()) {
				asec_syncDB();
			}
		}
		asec_mailNotify(0);
	}
}

?>
